'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _intro = require('intro.js');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _PropTypes = require('../proptypes/PropTypes');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var IntrojsProvider = function (_Component) {
  _inherits(IntrojsProvider, _Component);

  function IntrojsProvider(props, context) {
    _classCallCheck(this, IntrojsProvider);

    var _this = _possibleConstructorReturn(this, (IntrojsProvider.__proto__ || Object.getPrototypeOf(IntrojsProvider)).call(this, props, context));

    _this.onExit = function () {
      var onExit = _this.props.onExit;


      _this.isVisible = false;

      onExit(_this.introJs._currentStep);
    };

    _this.onBeforeChange = function (element) {
      if (!_this.isVisible) {
        return;
      }

      var onBeforeChange = _this.props.onBeforeChange;


      if (onBeforeChange) {
        onBeforeChange(_this.introJs._currentStep, element);
      }
    };

    _this.onAfterChange = function (element) {
      if (!_this.isVisible) {
        return;
      }

      var onAfterChange = _this.props.onAfterChange;


      if (onAfterChange) {
        onAfterChange(_this.introJs._currentStep, element);
      }
    };

    _this.onChange = function (element) {
      if (!_this.isVisible) {
        return;
      }

      var onChange = _this.props.onChange;


      if (onChange) {
        onChange(_this.introJs._currentStep, element);
      }
    };

    _this.onComplete = function () {
      var onComplete = _this.props.onComplete;


      if (onComplete) {
        onComplete();
      }
    };

    _this.setIntrojsSteps = function (steps) {
      _this.steps = steps;
      // if (!this.isVisible) {
      //   return;
      // }
      // const currentStep = this.introJs._currentStep;
      // this.introJs.exit();
      // this.introJs.start();
      // this.introJs.goToStep(currentStep + 1);
    };

    _this.getIntrojsSteps = function () {
      return _this.steps;
    };

    _this.setIntrojsHints = function (hints) {
      _this.hints = hints;
    };

    _this.getIntrojsHints = function () {
      return _this.hints;
    };

    _this.introjsIsConfigured = function () {
      return _this.isConfigured;
    };

    _this.steps = [];
    _this.stepsData = [];
    _this.hints = [];
    _this.isVisible = false;
    _this.isConfigured = false;
    _this.installIntroJs();
    return _this;
  }

  _createClass(IntrojsProvider, [{
    key: 'getChildContext',
    value: function getChildContext() {
      return {
        setIntrojsSteps: this.setIntrojsSteps.bind(this),
        getIntrojsSteps: this.getIntrojsSteps.bind(this),
        setIntrojsHints: this.setIntrojsHints.bind(this),
        getIntrojsHints: this.getIntrojsHints.bind(this),
        startRenderIntrojsSteps: this.startRenderSteps.bind(this),
        introjsIsConfigured: this.introjsIsConfigured.bind(this)
      };
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.configureIntroJs();
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.introJs.exit();
    }
  }, {
    key: 'installIntroJs',
    value: function installIntroJs() {
      this.introJs = (0, _intro.introJs)();
      this.introJs.onexit(this.onExit);
      this.introJs.onbeforechange(this.onBeforeChange);
      this.introJs.onafterchange(this.onAfterChange);
      this.introJs.onchange(this.onChange);
      this.introJs.oncomplete(this.onComplete);
    }
  }, {
    key: 'configureIntroJs',
    value: function configureIntroJs() {
      var _this2 = this;

      var _props = this.props,
          options = _props.options,
          onConfigureIntroJs = _props.onConfigureIntroJs,
          afterConfiguredIntroJs = _props.afterConfiguredIntroJs;

      onConfigureIntroJs().then(function (steps) {
        _this2.introJs.setOptions(_extends({}, options, { steps: steps }));
        _this2.stepsData = steps;
        _this2.isConfigured = true;
        if (afterConfiguredIntroJs) afterConfiguredIntroJs.call(_this2, _this2);
      });
    }
  }, {
    key: 'startRenderSteps',
    value: function startRenderSteps() {
      var initialStep = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0;
      var onStart = this.props.onStart;


      if (this.stepsData.length > 0 && !this.isVisible) {
        this.introJs.start();

        this.isVisible = true;

        this.introJs.goToStepNumber(initialStep + 1);

        if (onStart) {
          onStart(this.introJs._currentStep);
        }
      }
    }
  }, {
    key: 'render',
    value: function render() {
      return _react.Children.only(this.props.children);
    }
  }]);

  return IntrojsProvider;
}(_react.Component);

IntrojsProvider.defaultProps = {
  onStart: null,
  onBeforeChange: null,
  onAfterChange: null,
  onChange: null,
  onComplete: null,
  afterConfiguredIntroJs: null,
  options: {}
};


IntrojsProvider.propTypes = {
  children: _propTypes2.default.element.isRequired,
  onExit: _propTypes2.default.func.isRequired,
  onConfigureIntroJs: _propTypes2.default.func.isRequired,
  afterConfiguredIntroJs: _propTypes2.default.func,
  onStart: _propTypes2.default.func,
  onBeforeChange: _propTypes2.default.func,
  onAfterChange: _propTypes2.default.func,
  onChange: _propTypes2.default.func,
  onComplete: _propTypes2.default.func,
  options: _PropTypes.optionsPropTypes
};

IntrojsProvider.childContextTypes = {
  setIntrojsSteps: _propTypes2.default.func.isRequired,
  getIntrojsSteps: _propTypes2.default.func.isRequired,
  setIntrojsHints: _propTypes2.default.func.isRequired,
  getIntrojsHints: _propTypes2.default.func.isRequired,
  startRenderIntrojsSteps: _propTypes2.default.func.isRequired,
  introjsIsConfigured: _propTypes2.default.func.isRequired
};
exports.default = IntrojsProvider;