'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function getDisplayName(WrappedComponent) {
  return WrappedComponent.displayName || WrappedComponent.name || 'IntrojsStepComponent';
}

exports.default = function (WrappedComponent, selector) {
  var connectedIntrojsStep = function (_Component) {
    _inherits(connectedIntrojsStep, _Component);

    function connectedIntrojsStep() {
      _classCallCheck(this, connectedIntrojsStep);

      return _possibleConstructorReturn(this, (connectedIntrojsStep.__proto__ || Object.getPrototypeOf(connectedIntrojsStep)).apply(this, arguments));
    }

    _createClass(connectedIntrojsStep, [{
      key: 'componentDidMount',
      value: function componentDidMount() {
        var steps = this.context.getIntrojsSteps();
        steps.push(selector);
        this.context.setIntrojsSteps(steps);
        var node = (0, _reactDom.findDOMNode)(this);
        if (node) node.setAttribute('introjs-step-id', selector);
      }
    }, {
      key: 'componentWillUnmount',
      value: function componentWillUnmount() {
        var steps = this.context.getIntrojsSteps();
        this.context.setIntrojsSteps(steps.filter(function (item) {
          return item !== selector;
        }));
      }
    }, {
      key: 'render',
      value: function render() {
        return _react2.default.createElement(WrappedComponent, this.props);
      }
    }]);

    return connectedIntrojsStep;
  }(_react.Component);

  connectedIntrojsStep.displayName = 'WithConnectedIntrojsStep(' + getDisplayName(WrappedComponent) + ')';
  connectedIntrojsStep.contextTypes = {
    setIntrojsSteps: _propTypes2.default.func.isRequired,
    getIntrojsSteps: _propTypes2.default.func.isRequired
  };
  return connectedIntrojsStep;
};